#ifndef DRAGLISTVIEW_H
#define DRAGLISTVIEW_H

#include <qlistview.h>
#include <qdragobject.h>
#include "linkedlist.h"
#include "kmpModule.h"
#include "dragListViewItem.h"

class Q_EXPORT dragListView : public QListView
{
    Q_OBJECT
public:
    dragListView(QWidget *parent = 0, const char *name = 0);
    ~dragListView();
    void setType(int type);
    void setPath(QString path);
    QString getPath();
protected:
    void startDrag();
    void dragEnterEvent(QDragEnterEvent* event);
    void dragMoveEvent ( QDragMoveEvent * );
    void dragLeaveEvent ( QDragLeaveEvent * );
    void dropEvent(QDropEvent* event);
    void resizeEvent ( QResizeEvent * e );
private:
    int type_;
    QString path_;
    dragListViewItem * findItem(QPoint loc);
    dragListViewItem * dropPainted;
signals:
    void recieveDrop(QString MType, dragListView * source, dragListViewItem * loc);
    void resized(QResizeEvent * e);
        
};

    


#endif
