/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/

//Name:  connectToServer
//When&What Calls:  the connect button when pressed
//Purpose:  
void kmpConnect::connectToServer()
{
    //If we are allready connected to a server, we disconnect from it
    if(!(conn==NULL)) {
        mpd_closeConnection(conn);
        conn = NULL;
        //And tell all of our connections to disconnect
        returnStatus(0, conn, " " , 0, "");
    }
    //Give the user some info
    statusText->setText("Connecting to Server...");
    //Connect to our new given server
    conn = mpd_newConnection(hostCombo->currentText(), portText->text().toInt() ,2);
    if(conn->error) {
        //If there was an error, we tell the user what the error was, and close all
        // all of our connections
        statusText->setText(conn->errorStr);
        mpd_closeConnection(conn);
        conn = NULL;
        returnStatus(0, conn, " ", 0, "");
        this->show();
        return;
    } else {
        //If we connected, send Password, (if Possible), check to see if Password Required. THEN return
 if( passText->text() != "") {
     mpd_sendPasswordCommand(conn, passText->text().ascii() );
     mpd_finishCommand(conn);
     if(conn->error) {
  statusText->setText("Invalid Password");
  mpd_closeConnection(conn);
  conn = NULL;
  returnStatus(0,conn,"",0, "");
  this->show();
  return;
     }
 }
 if(conn->error)  {
     statusText->setText("Server Requires Password");
     mpd_closeConnection(conn);
     conn = NULL;
     returnStatus(0,conn, "", 0, "");
     this->show();
     return;
 }
 statusText->setText("Connected!");
 addServer(hostCombo->currentText());
 returnStatus(1,conn, hostCombo->currentText(), portText->text().toInt(), passText->text() );
 close();
    }
}
  
//Name:  setConn
//When&What Calls:  this is called by the main window
//Purpose:  To have this window know what we are connected to all ready
void kmpConnect::setConn( mpd_Connection * & conn_)
{
    //Store the main windows connection
    conn = conn_;
}



void kmpConnect::addServer( QString servername )
{
    QStringList myList;
    myList = stored.grep(servername);
    for ( QStringList::Iterator it = stored.begin(); it != stored.end(); ++it ) {
	if(*it == servername) return;
    } 
    stored+=servername;
}


void kmpConnect::checkForAC( const QString & server )
{
    if(server == ACname) {
	portText->setText(QString::number(ACport));
	passText->setText(ACpassword);
	cb_autoConn->setChecked(TRUE);
    } else {
	cb_autoConn->setChecked(FALSE);
    }
}
void kmpConnect::checkForACPort( const QString& port)
{
    int curPort = port.toInt();
    if( hostCombo->currentText() == ACname  && curPort == ACport) {
	cb_autoConn->setChecked(TRUE);
    } else {
	cb_autoConn->setChecked(FALSE);
    }	
}

void kmpConnect::acChanged() {
    if(cb_autoConn->isChecked()) {
	ACname = hostCombo->currentText();
	ACport = portText->text().toInt();
    } else {
	ACname = "";
	ACport = 0;
	ACpassword = "";
    }
}


void kmpConnect::setList( QStringList theList )
{
    hostCombo->clear();
    hostCombo->insertStringList(theList);
    stored = theList;
    if( hostCombo->count() ==0) {
	stored += "localhost";
	hostCombo->clear();
	hostCombo->insertStringList(stored);
    }
}


void kmpConnect::autoConnect( QString Server, int Port , QString Password)
{
    hostCombo->setCurrentText(Server);
    portText->setText(QString::number(Port));
    passText->setText(Password);
    ACname = Server;
    ACport = Port;
    ACpassword  = Password;
    cb_autoConn->setChecked(TRUE);
    connectToServer();
}

void kmpConnect::init() {
    conn = NULL;
}


void kmpConnect::passChanged( const QString & pass )
{
    if(cb_autoConn->isChecked()) {
	ACpassword = pass;
    }
}
