/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/


//Name:  changeStatus
//When&What Calls:  This is normally called by the Update Status
//Purpose:  To change the status of all of the widgets on the main form
void kmpMain::changeStatus(int status)
{
    //First we set all of the buttons to there respective status (enabled/unenabled)
    if(!volDisabled && status) volumeBar->setEnabled(status);
    btn_prev->setEnabled(status);
    btn_stop->setEnabled(status);
    btn_PlayPause->setEnabled(status);
    btn_next->setEnabled(status);
    progressBar->setEnabled(status);
    randomL->setEnabled(status);
    repeatL->setEnabled(status);
    //Now we see what the third button should be (play/pause)
    if(status == MPD_STATUS_STATE_PLAY) {
	//If we are playing, make the button PAUSE the player
	btn_PlayPause->setPixmap(pauseIcon);
    } else {
	//If we are not playing, make the button PLAY
	btn_PlayPause->setPixmap(playIcon);
    }
    //Finally we check to see if we are STOPPED (not paused)
    //	if we are we then set the current progress in the song to 0
    if(status == MPD_STATUS_STATE_STOP) {
	//Set the progress widget to 0 (beginning of a song)
	progressBar->setValue(0);
	mainBar->setText("");
	bitrate->setText("0");
	curTime->setText(minTime(0));
	ChangedMainBar=true;
    }

}



//Name:  init()
//When&What Calls:  This is automatically called when the app starts
//Purpose:  To get KMP ready for all the kick ass things it will do.
void kmpMain::init()
{
    //**************MISC***************
    //Have the initial status bar message "Not Connected"
    //statusBar()->message("Not Connected.");
    //These variables tell the client on status updates not to
    //update the respective widgets (So when dragging the indicator
    //it doesn't put it in the "Correct" spot
    progressPause = FALSE;
    volumePause = FALSE;
    volDisabled = FALSE;
    negTime = FALSE;
    //Make the width of the bitrate the correct size for the current font
   // bitrate->setMaximumWidth(QFontMetrics(bitrate->font()).width("222"));
   // bitrate->setMinimumWidth(QFontMetrics(bitrate->font()).width("222"));
    QFont myFont;
    myFont.setBold(1);
    curTime->setFont(myFont);
    //**********************************
    
    //*************Set Main Window Sizes****
    int heightOfText = QFontMetrics(kbpsLabel->font()).height();
    mainBar->setGeometry(0,-1,318,heightOfText+4);
    mainBar->setMinimumSize(QSize(5, heightOfText+4));
    mainBarFrame->setMinimumSize(QSize(320,heightOfText+5));
    mainBarFrame->setGeometry(2,2,320,heightOfText+5);
    bitrate->setGeometry(5 , heightOfText+10 , QFontMetrics(bitrate->font()).width("2222"), heightOfText);
    int curSpot = 5+ QFontMetrics(bitrate->font()).width("2222");
    kbpsLabel->setGeometry(curSpot+3, heightOfText+10, QFontMetrics(kbpsLabel->font()).width("kbps"), heightOfText);
    curTime->setGeometry(321 - QFontMetrics(curTime->font()).width("-99:99"), heightOfText + 10, QFontMetrics(curTime->font()).width("-99:99"), heightOfText);
    
    curSpot+= QFontMetrics(kbpsLabel->font()).width("kbps") + 3;
    int space = (321 - QFontMetrics(curTime->font()).width("-99:99")) - curSpot;
    int padding = (space - 2* QFontMetrics(randomL->font()).width("random: off ")) / 3;
    randomL->setGeometry(curSpot + padding , heightOfText +10, QFontMetrics(randomL->font()).width("random: off "), heightOfText);
    curSpot += QFontMetrics(randomL->font()).width("random: off ") + padding;
    repeatL->setGeometry(curSpot + padding, heightOfText + 10, QFontMetrics(repeatL->font()).width("repeat: off "), heightOfText);
    LCD->setMinimumSize(QSize(325,2*heightOfText + 16));
    LCD->setMaximumSize(QSize(325,2*heightOfText + 16));   
    //*************************************
    
    //**********LOAD ICONS***********
    icons * MyIcons;
    MyIcons = new icons;
    playIcon = MyIcons->playI;
    pauseIcon = MyIcons->pauseI;

    delete MyIcons;
//    playIcon.load("pics/play.png");
//    pauseIcon.load("pics/pause.png");
    btn_PlayPause->setPixmap(playIcon);
    //**********************************
    
    //*******scrollLoop********
    //Create the Timer
    QTimer* scrollLoop = new QTimer(this);
    //Start the timer, with interval at 100ms (MIGHT ADD ABILITY TO CHANGE THIS)
    scrollLoop->start(100);
    //connect the scrollLoop timeout with the slot to move the main scrolling title
    //so that we will have a smooth scrolling title bar
    connect(scrollLoop, SIGNAL(timeout()), this, SLOT(ScrollIncrement()));
    //*************************

    
    statusBar()->setSizeGripEnabled(FALSE);
}


//Name:  Scroll Increment()
//When&What Calls:  This is called by the scrolltimer every 100ms
//Purpose:  To have the main title bar scroll when needed
void kmpMain::ScrollIncrement()
{
    //First we check if the text in the bar has changed
    if(ChangedMainBar) {
	//If the main bar has been changed, we must:
	//    1)reset the scrolling direction
	ScrollDirection = -1;
	//    2)reset the size of the bar to fit the text EXACTLY
	mainBar->setGeometry(2,-1,QFontMetrics(mainBar->font()).width(mainBar->text()), 20);
	//    3)reset the variable, so we don't keep fixing the main bar
	ChangedMainBar = FALSE;
    } else {
	//If we HAVEN'T changed the bar, we do the normal scrolling operations
	//  if we are at the end of the scroll, we pause for 2 seconds (20 100ms intervals)
	if(pauseScroll ) {
	    //Next we check to see if we have finished our pause
	    if(countForPause++ > 20) pauseScroll=FALSE;
	    //   if we haven't exit this function
	         else return;
	 }
	//Next we get the size of the main bar, so we know how big it is
	//	and thus how far we need to move it to see all of it
	QRect GetRect = mainBar->geometry();
	//If the size of the text is SMALLER then the size of the viewable area
	//	(around 317 pixels) then exit the function, no scrolling needed
	if(GetRect.width() < 317) return;
	//Otherwise set the new spot for the main bar
	GetRect.setLeft(GetRect.left() + ScrollDirection * 2);
	GetRect.setWidth(GetRect.width() + ScrollDirection * 2);
	//Then make these changes to the widget
	mainBar->setGeometry(GetRect);
	//Then we see if the we have reached an end
	if((GetRect.left() + GetRect.width() < 317) || GetRect.left() > 0) {
	    //If we have reached an end, start the scroll pause
	    countForPause = 0;
	    pauseScroll = TRUE;
	    //And change the direction of the scroll
	    ScrollDirection = ScrollDirection * (-1);
	}
    }
}


//Name:  pauseVolume()
//When&What Calls:  This is called when the user Clicks DOWN on the volume bar
//Purpose:  To stop the status from updating the volume and get the intial volume
void kmpMain::pauseVolume()
{
    //by setting this variable to TRUE, we are telling the status to skip over volume when
    //	updating
    volumePause = TRUE;
}

//Name:  unpauseVolume()
//When&What Calls:  this is called when the user lets up on the mouse button
//Purpose:  To send the change volume command to the server
void kmpMain::unpauseVolume()
{
    //We send the server the change volume command
    sendVolume(volumeBar->value());
    //And by setting this variable to false, we are telling the status updates to resume
    //	updating the volume bar
    volumePause = FALSE;

}
//Name:  pauseProgress()
//When&What Calls:  This is called when the user Clicks DOWN on the volume bar
//Purpose:  To stop the status from updating the volume and get the intial volume
void kmpMain::pauseProgress()
{
    //by setting this variable to TRUE, we are telling the status to skip over volume when
    //	updating
    progressPause = TRUE;
}

//Name:  unpauseProgress()
//When&What Calls:  this is called when the user lets up on the mouse button
//Purpose:  To send the change volume command to the server
void kmpMain::unpauseProgress()
{
    //We send the server the change volume command
    sendSeek((double)(progressBar->value()) / 1000.0);
    //And by setting this variable to false, we are telling the status updates to resume
    //	updating the bar
    progressPause = FALSE;

}

//Name:  closeEvent
//When&What Calls: This is called when the main window has closed 
//Purpose:  At the moment it closes all of the windows, and de-allocates
//		all memory that we have allocated

void kmpMain::toggleNegTime()
{
    negTime = !negTime;
}
bool kmpMain::getNegTime()
{
    return negTime;
}
void kmpMain::tRepeat() {
    toggleRepeat();
}
void kmpMain::tRandom() {
    toggleRandom();
}
void kmpMain::tBrowse() {
    toggleBrowse();
}
void kmpMain::tPlaylist() {
    togglePlaylist();
}
void kmpMain::sAbout() {
    showAbout();
}
void kmpMain::sOptions() {
    showOptions();
}
void kmpMain::sConnect() {
    showConnect();
}
void kmpMain::sNext() {
    sendNext();
}
void kmpMain::sPrev() {
    sendPrev();
}
void kmpMain::sPlay() {
    sendPlay();
}
void kmpMain::sStop() {
    sendStop();
}


void kmpMain::update( int songTime, int songBitrate )
{
    //Now we need to set the time ticker to the current time we are at
    //	 I used a sub-function here, so that
    //	at 9 seconds it would display 09, not 9.

    if(songTime == -1) songTime =0;
    if(negTime) {
	curTime->setText("-" + minTime((int)curSongLen - (int)songTime));
    } else {
	curTime->setText(" " + minTime((int)songTime));
    }
   
	    
    //Then we update the bitrate. (As it can change through the song)
    bitrate->setText(QString::number(songBitrate));
    //Next we check to see if we should not update the widget
    //	this is normally when the user is dragging on the position
    //	of the song to seek.
    if(curSongLen != 0) {
	    //Also used to see if a song is loaded (or avaible to get info
	    //	time info on
	    //Now we get the current position of the status bar (which
	    //	has 1000 intervals on it, so we multiply the % 
	    //	complete of the song by 1000 to get which interval
	    //	it should be on)
	QToolTip::add( mainBar, tooltip(curSongStore, songTime));
	int currentPos = (int)(1000 * ((double)songTime / (double)curSongLen));
	if(!progressPause) progressBar->setValue(currentPos);
    }
}


void kmpMain::newSong( mpd_SongStore aSong )
{
    //We set the new values for the song
    curSongStore = aSong;
    curSongLen = aSong.time;
    if(showFilenameOnly) {
	MainBarText = fileTitle(aSong.file);
    } else {
	MainBarText = title(aSong);
    }
		
    //And update this text to the widget
    mainBar->setText(MainBarText);
    //And since we updated the playlist, we need to tell the scroll to
    //	update its information.
    ChangedMainBar = TRUE;
}


void kmpMain::setRandom( bool value )
{
    if(value) randomL->setText("random: on");
	else randomL->setText("random: off");
}


void kmpMain::setRepeat( bool value )
{
    if(value) repeatL->setText("repeat: on");
     else repeatL->setText("repeat: off");
}

void kmpMain::setVolDisabled(bool value )
{
    volDisabled = value;
    volumeBar->setEnabled(false);
}

void kmpMain::setVolume(int value )
{
    if(!volumePause) volumeBar->setValue(value);
}

void kmpMain::setBrowseVis(bool on) {
    btn_br->setOn(on);
    windowBrowse->setOn(on);
}
void kmpMain::setPlaylistVis(bool on) {
    btn_pl->setOn(on);
    windowPlaylist->setOn(on);    
}
void kmpMain::closeEvent( QCloseEvent * a) {
    closed();
    this->hide();
    a->ignore();
}


void kmpMain::setFilenameOnly( bool value )
{
    showFilenameOnly = value;
}


void kmpMain::setColors( QColor LCDbg_, QColor LCDfg_ )
{
    LCD->setPaletteBackgroundColor(LCDbg_);
    LCD->setPaletteForegroundColor(LCDfg_);
    bitrate->setPaletteBackgroundColor(LCDbg_);
    bitrate->setPaletteForegroundColor(LCDfg_);
    kbpsLabel->setPaletteBackgroundColor(LCDbg_);
    kbpsLabel->setPaletteForegroundColor(LCDfg_);
    curTime->setPaletteBackgroundColor(LCDbg_);
    curTime->setPaletteForegroundColor(LCDfg_);
    mainBar->setPaletteBackgroundColor(LCDbg_);
    mainBar->setPaletteForegroundColor(LCDfg_);
}

void kmpMain::getBgColors(int &r, int &g, int &b)
{
    r = LCD->paletteBackgroundColor().red();
    g = LCD->paletteBackgroundColor().green();
    b = LCD->paletteBackgroundColor().blue();
}
void kmpMain::getFgColors(int &r, int &g, int &b)
{
    r = LCD->paletteForegroundColor().red();
    g = LCD->paletteForegroundColor().green();
    b = LCD->paletteForegroundColor().blue();   
}


void kmpMain::toggleW()
{
    toggleWindow();
}


void kmpMain::postStatusBar( QString Message )
{
    statusBar()->message(Message);
}


void kmpMain::setStatusbar( bool visible )
{
    statusVisible = visible;
    if(visible) {
	setMinimumHeight(154);
	setMaximumHeight(153);
	setFixedSize(350,154);
	statusBar()->show();
    } else {
	statusBar()->hide();
	setMinimumHeight(135);
	setMaximumHeight(134);
	setFixedSize(350, 135);
    }
}


bool kmpMain::getStatusVis()
{
    return statusVisible;
}


void kmpMain::killMe()
{
    kill();
}
